/******************************************************************************
#include section
******************************************************************************/
 #include <PIC16F_I2C_MasterFunctions.h>

/******************************************************************************
Global Variables
******************************************************************************/
char txt[4];
int result = 0;
unsigned char count = 0;

// LCD module connections /////////////////////////////////////////////////////
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End LCD module connections /////////////////////////////////////////////////

/******************************************************************************
Global Constants
******************************************************************************/


/******************************************************************************
Main Program
******************************************************************************/
void main()
{
  ANSEL  = 0;                        // Configure AN pins as digital I/O
  ANSELH = 0;
  C1ON_bit = 0;                      // Disable comparators
  C2ON_bit = 0;
  TRISB = 0;                 // Configure PORTB as output
  PORTB = 0;
  TRISA=0;
  PORTA = 0;

  I2C1_Init(100000);         // initialize I2C communication
  Lcd_Init();                        // Initialize LCD
  Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off

  while(1)
  {
/******************************************************************************
The bellow code demonstrates the use of the provided libraries
Two bytes are send to slave, the slave perform the aritmetic sum between them.
The master read the result.
All this is printed on the lcd. If from some reason the result is not the expected
one a message will be printed on the LCD beside the result. If all the checks were
correctly performed "Success" message will be printed on LCD for 50 seconds.
To test that timeout works you can remove one of I2C wires while a request is in
progress. A message "Failed" will be printed on the LCD for 5 seconds. 
Also notice that if the slave perform other operations that take some time,
you may consider adding a delay after you write the second value and reading the result.
******************************************************************************/
     for (count = 0; count <= 127; count++)
     {
         PORTA = 0b00000011;
         result = I2C_MasterWriteEx(0b00111111,0,count);
         result = I2C_MasterWriteEx(0b00111111,1,count);
         ByteToStr(count,txt);
         Lcd_Out(1,1,txt);
         Lcd_Out(1,6,"+");
         Lcd_Out(1,7,txt);
         result = I2C_MasterReadEx(0b00111111,2);
         ByteToStr(result,txt);
         Lcd_Out(2,4,txt);
         if (result != count + count)
         {
               ByteToStr(result,txt);
               if (result<0)
               {
                  Lcd_Out(2,7,"TIMEOUT!");
               }
               else
               {
                  Lcd_Out(2,7,"FAILED!!!");
               }
               PORTA = PORTA ^ 0b00000001;
               Delay_ms(5000);
               Lcd_Cmd(_LCD_CLEAR);               // Clear display
         }
         Delay_ms(1000);
     }
     Lcd_Cmd(_LCD_CLEAR);               // Clear display
     Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
     Lcd_Out(1,1,"SUCCESS!!!");
     Delay_ms(50000);
     Lcd_Cmd(_LCD_CLEAR);               // Clear display
  }
}