#line 1 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F_I2C_MasterFunctions.c"
#line 47 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F_I2C_MasterFunctions.c"
int I2C_WriteEx(unsigned char dat, unsigned long timeout_us)
{
 int result = 0;
 Delay_us(100);
 PIR1 = PIR1&0b11110111;
 SSPBUF = dat;
 while (R_NOT_W==0 && timeout_us > 0)
 {
 timeout_us-=1;
 if (R_NOT_W==0)
 {
 Delay_us(1);
 }
 }
 if (timeout_us==0)
 {
 PORTA=PORTA|0b00000001;
 SSPCON2=SSPCON2|0b00000100;
 result = -1;
 goto _exitPoint;
 }
 while (SSPIF==0 && timeout_us > 0)
 {
 timeout_us-=1;
 if (SSPIF==0)
 {
 Delay_us(1);
 }
 }
 if (timeout_us==0)
 {
 PORTA=PORTA|0b00000010;
 SSPCON2=SSPCON2|0b00000100;
 result = -1;
 goto _exitPoint;
 }
 if (ACKSTAT==0)
 {
 asm nop;
 }
 {
 SSPCON2=SSPCON2|0b00000100;
 result = -2;
 }
_exitPoint:
 return result;
}
#line 105 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F_I2C_MasterFunctions.c"
int I2C_ReadEx(char acknowledge, unsigned long timeout_us)
{
 int result = -1;
 Delay_us(100);
 PIR1 = PIR1&0b11110111;
 SSPCON2 = SSPCON2|0b00001000;
 while(timeout_us>0 && !(PIR1&0b00001000))
 {
 timeout_us-=1;
 if (!(PIR1&0b00001000))
 {
 Delay_us(1);
 }
 }
 if (timeout_us==0)
 {
 PORTA=PORTA|0b00000100;
 SSPCON2=SSPCON2|0b00000100;
 }
 else
 {
 result = SSPBUF;
 }
 if (acknowledge==0)
 {
 SSPCON2 = SSPCON2|0b00100000;
 }
 else
 {
 SSPCON2 = SSPCON2&0b11011111;
 }
 PIR1 = PIR1&0b11110111;
 SSPCON2 = SSPCON2|0b00010000;
 while(timeout_us>0 && !(PIR1&0b00001000))
 {
 timeout_us-=1;
 if (!(PIR1&0b00001000))
 {
 Delay_us(1);
 }
 }
 if (timeout_us==0)
 {
 PORTA=PORTA|0b00001000;
 SSPCON2=SSPCON2|0b00000100;
 result = -1;
 }
 return result;
}
#line 167 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F_I2C_MasterFunctions.c"
int I2C_MasterWriteEx(unsigned char chipAddress, unsigned char slaveRegister, unsigned char input)
{
 int result = 0;
 unsigned char cdata;
 unsigned char header = 0;
 char count;

 I2C1_Start();
 chipAddress = chipAddress<<1;
 I2C_WriteEx(chipAddress, 200 );
 header =  64 ;
 header = header | 0b10000000;
 header = header | (slaveRegister &  31 );
 result = I2C_WriteEx(header, 200 );
 I2C1_Stop();

 I2C1_Start();
 I2C_WriteEx(chipAddress|1, 200 );
 result = I2C_ReadEx( 0 , 200 );
 I2C1_Stop();

 if (result>=0 && result == header)
 {
 for(count = 0; count<2; count++)
 {
 if (count==0)
 {
 cdata = input& 15 ;
 }
 else
 {
 cdata = (input>>4)& 15 ;
 cdata = cdata | 0b10000000;
 }
 I2C1_Start();
 result = I2C_WriteEx(chipAddress, 200 );
 result = I2C_WriteEx(cdata, 200 );
 I2C1_Stop();

 I2C1_Start();
 I2C_WriteEx(chipAddress|1, 200 );
 result = I2C_ReadEx( 0 , 200 );
 I2C1_Stop();

 if (result<0 || result != cdata)
 {
 break;
 }
 }
 }
 return result;
}
#line 231 "F:/Documente/Redresor new/PicTests/PIC16F887_I2CMaster_Protocol/PIC16F_I2C_MasterFunctions.c"
int I2C_MasterReadEx(unsigned char chipAddress, unsigned char slaveRegister)
{
 unsigned char result = 0;
 char counter = 0;
 char header = 0;
 int tempResult = -1;
 chipAddress = chipAddress<<1;
 for (counter=0; counter<2; counter++)
 {
 header = counter<< 7 ;
 header = header |  64 ;
 header = header |  32 ;
 header = header | (slaveRegister &  31 );
 I2C1_Start();
 I2C_WriteEx(chipAddress, 200 );
 I2C_WriteEx(header, 200 );
 I2C1_Stop();
 I2C1_Start();
 I2C_WriteEx(chipAddress|1, 200 );
 tempResult = I2C_ReadEx( 0 , 200 );
 I2C1_Stop();
 if (tempResult<0)
 {
 result = tempResult;
 return;
 }
 else
 {
 tempResult = tempResult &  15 ;
 tempResult = tempResult << (counter * 4);
 result = result | tempResult;
 }
 }
 return result;
}
