/***************************************************************************************/
/* Demo for driving PIC16Fxx as I2C-Master according to Application Note AN734         */
/*                                                                                     */
/* Master                                                                              */
/*                                                                                     */
/* Description: This example is indended to demonstrate several capabilities of I2C bus*/
/*              - master/slave communication                                           */
/*              - timeout in case of communiation failure                              */
/*              - capability of sending unsigned char variables to 32 different        */
/*                internal UC registers                                                */
/*              - variable data lenght                                                 */
/*                                                                                     */
/* Mikrocontroller:       PIC16F887                                                    */
/* Clock:                 internal clock (8.0 MHz)                                     */
/*                                                                                     */
/* Compiler:              mikroC V6.6.2                                                */
/*                                                                                     */
/* Developer:            Mitroi Nicolae Alexandru                                      */
/* Stert of software development: 01. August 2016                                      */
/* Last updated:                  05. August 2016                                      */
/***************************************************************************************/


int I2C_WriteEx(unsigned char dat, unsigned long timeout_us);
int I2C_ReadEx(char acknowledge, unsigned long timeout_us);
int I2C_MasterWriteEx(unsigned char chipAddress, unsigned char slaveRegister, unsigned char input);
int I2C_MasterReadEx(unsigned char chipAddress, unsigned char slaveRegister);