#line 1 "C:/Users/AlexsiVio/Desktop/PicTests/PIC16F887_I2CSlave_Protocol/PIC16F887_I2CSlaveHelpers.c"
#line 16 "C:/Users/AlexsiVio/Desktop/PicTests/PIC16F887_I2CSlave_Protocol/PIC16F887_I2CSlaveHelpers.c"
extern char cI2CAddress;
extern char cI2CData;
extern unsigned char ucI2CRegisters[ 32 ];
extern unsigned char ucI2CRegistersStatus[ 32 ];
extern char cI2CCurrentRegisterNumber;
extern char cI2CTotalMsgCount;
extern char cI2CCurrentMsgCount;
extern char ucI2CCurrentStatus;
extern char cI2CR_W_Operation;
#line 30 "C:/Users/AlexsiVio/Desktop/PicTests/PIC16F887_I2CSlave_Protocol/PIC16F887_I2CSlaveHelpers.c"
extern const unsigned char _I2C_WRITE = 0;
extern const unsigned char _I2C_READ = 1;

extern const unsigned char _I2C_STATUS_IDLE = 0;
extern const unsigned char _I2C_STATUS_STARTED = 1;
extern const unsigned char _I2C_STATUS_INPROGRESS = 2;
extern const unsigned char _I2C_STATUS_ERROR = 3;
extern const unsigned char _I2C_STATUS_END = 4;

extern const unsigned char _I2C_ADDRESS = 0;
extern const unsigned char _I2C_DATA = 1;
#line 54 "C:/Users/AlexsiVio/Desktop/PicTests/PIC16F887_I2CSlave_Protocol/PIC16F887_I2CSlaveHelpers.c"
unsigned char PrepareResponseData(unsigned char input)
{
 unsigned char result = 0;
 char receivedMessageCount;
 unsigned long tempVariable;
 receivedMessageCount = input >>  7 ;
 if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber< 32 )
 {
 tempVariable = ucI2CRegisters[cI2CCurrentRegisterNumber];
 tempVariable = tempVariable>>(receivedMessageCount*4);
 tempVariable = tempVariable&0x0F;
 tempVariable = tempVariable | (receivedMessageCount<< 7 );
 result = tempVariable;
 }
 return result;
}
#line 85 "C:/Users/AlexsiVio/Desktop/PicTests/PIC16F887_I2CSlave_Protocol/PIC16F887_I2CSlaveHelpers.c"
char ParseI2CHeader(unsigned char input)
{
 char result = -1;
 if (input & 0b01000000)
 {
 cI2CCurrentRegisterNumber = input&0b00011111;
 cI2CR_W_Operation = input&0b00100000;
 if (input&0b00100000)
 {
 cI2CR_W_Operation = _I2C_WRITE;
 cI2CData = PrepareResponseData(input);
 result = 1;
 }
 else
 {
 cI2CR_W_Operation = _I2C_READ;
 if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber< 32 )
 {
 ucI2CCurrentStatus = _I2C_STATUS_STARTED;
 ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_STARTED;
 ucI2CRegisters[cI2CCurrentRegisterNumber] = 0;
 cI2CTotalMsgCount = input>> 7 ;
 result = 1;
 }
 }
 }
 return result;
}
#line 127 "C:/Users/AlexsiVio/Desktop/PicTests/PIC16F887_I2CSlave_Protocol/PIC16F887_I2CSlaveHelpers.c"
char ParseI2CData(unsigned char input)
{
 char result = -1;
 unsigned long mask;
 char receivedMessageCount = -1;
 if (input & 0b01000000)
 {
 ucI2CCurrentStatus = _I2C_STATUS_ERROR;
 }
 else
 {
 if (cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber< 32 )
 {
 mask = input & 0b00001111;
 receivedMessageCount = input >>  7 ;
 cI2CCurrentMsgCount+=1;
 if (receivedMessageCount!=cI2CCurrentMsgCount || cI2CCurrentMsgCount > cI2CTotalMsgCount)
 {
 ucI2CCurrentStatus = _I2C_STATUS_ERROR;
 ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_ERROR;
 ucI2CRegisters[cI2CCurrentRegisterNumber] = 0;
 cI2CCurrentRegisterNumber = -1;
 cI2CTotalMsgCount = -1;
 cI2CCurrentMsgCount = -1;
 }
 else
 {
 mask = mask<<(4*cI2CCurrentMsgCount);
 ucI2CRegisters[cI2CCurrentRegisterNumber] = ucI2CRegisters[cI2CCurrentRegisterNumber] | mask;
 if (cI2CCurrentMsgCount < cI2CTotalMsgCount)
 {
 ucI2CCurrentStatus = _I2C_STATUS_INPROGRESS;
 ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_INPROGRESS;
 result = 1;
 }
 else if (cI2CCurrentMsgCount == cI2CTotalMsgCount)
 {
 ucI2CCurrentStatus = _I2C_STATUS_END;
 ucI2CRegistersStatus[cI2CCurrentRegisterNumber] = _I2C_STATUS_END;
 cI2CCurrentRegisterNumber = -1;
 cI2CTotalMsgCount = -1;
 cI2CCurrentMsgCount = -1;
 result = 1;
 }
 }
 }
 }
 return result;
}
#line 189 "C:/Users/AlexsiVio/Desktop/PicTests/PIC16F887_I2CSlave_Protocol/PIC16F887_I2CSlaveHelpers.c"
void ParseI2CInput(unsigned char input)
{
 if (ucI2CCurrentStatus == _I2C_STATUS_IDLE || ucI2CCurrentStatus == _I2C_STATUS_ERROR || ucI2CCurrentStatus == _I2C_STATUS_END)
 {
 ParseI2CHeader(input);
 }
 else if (ucI2CCurrentStatus == _I2C_STATUS_STARTED || ucI2CCurrentStatus == _I2C_STATUS_INPROGRESS)
 {
 if ((cI2CCurrentRegisterNumber>=0 && cI2CCurrentRegisterNumber< 32 )
 &&(ucI2CRegistersStatus[cI2CCurrentRegisterNumber] == _I2C_STATUS_STARTED || ucI2CRegistersStatus[cI2CCurrentRegisterNumber] == _I2C_STATUS_INPROGRESS))
 {
 ParseI2CData(input);
 }
 else
 {
 ucI2CCurrentStatus = _I2C_STATUS_ERROR;
 }
 }
 if (ucI2CCurrentStatus == _I2C_STATUS_END)
 {
 ucI2CCurrentStatus = _I2C_STATUS_IDLE;
 }
}
#line 224 "C:/Users/AlexsiVio/Desktop/PicTests/PIC16F887_I2CSlave_Protocol/PIC16F887_I2CSlaveHelpers.c"
void ManageI2CBus()
{
 if (SSPSTAT.R_W == _I2C_WRITE)
 {


 if (SSPSTAT.D_A == _I2C_ADDRESS)
 {


 cI2CAddress = SSPBUF;
 SSPSTAT.BF = 0;
 }
 else
 {


 cI2CData = SSPBUF;

 ParseI2CInput(cI2CData);
 }
 }
 else
 {

 if (SSPSTAT.D_A == _I2C_ADDRESS)
 {


 SSPBUF = cI2CData;
 }
 else
 {


 SSPBUF = cI2CAddress;
 }
 }
 SSPCON.CKP = 1;
 PIR1.SSPIF = 0;
}
